#!/usr/bin/env LC_ALL=ja_JP.utf-8 python
#-*- coding: utf-8 -*-

import urllib
import sys
reload(sys)
sys.setdefaultencoding('utf-8')

import codecs

from bs4 import BeautifulSoup

yahoo_api_key = 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' # Application ID
pos_table = [u'名詞']

if len(sys.argv) <= 1:
    print("python %s <document>" % sys.argv[0])
    exit()
else:
    fileName = sys.argv[1]

MIN_WORD_SIZE = 3

def yahoo_morph(sentence, results="ma", filter='1|2|3|4|5|6|7|8|9|10|11|12|13'):
    pageurl = 'http://jlp.yahooapis.jp/MAService/V1/parse'
    postdata = {
        'appid'    : yahoo_api_key,
        'results'  : results,
        'filter'   : filter,
        'response' : 'surface,reading,pos,baseform',
        'sentence' : sentence.encode('utf-8')
    }
    params = urllib.urlencode(postdata).encode(encoding='ascii')
    result = urllib.urlopen(pageurl, params)

    soup = BeautifulSoup(result.read(), "html.parser")
    return [{
        'surface'  : w.surface.string,
        'baseform' : w.baseform.string,
        'reading'  : w.reading.string,
        'pos'      : w.pos.string
        } for w in soup.ma_result.word_list]

# ファイルからのテキストの読み込み
f = codecs.open(fileName,'r','utf-8')
data = f.read()
f.close()

keywords = []
morph = yahoo_morph(data)
document = ' '.join([t['baseform'] for t in morph if t['pos'] in pos_table and len(t['baseform']) >= MIN_WORD_SIZE])

print(document)
